package com.weaver.seconddev.jcl.organization.controller;

import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.seconddev.jcl.organization.service.EmployeeRelationService;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/api/secondev/jcl/employeeRelation")
public class EmployeeRelationController {

    private static final Logger log = LoggerFactory.getLogger(EmployeeRelationController.class);

    @Autowired
    private EmployeeRelationService employeeRelationService;

    /**
     * 查询结果回写数据
     * @return
     */
    @WeaPermission(publicPermission = true)
    @Produces(MediaType.APPLICATION_JSON)
    @GetMapping("/writeBackRecord")
    public Map<String, Object> writeBackRecord(
            @RequestParam("yearMonth") String yearMonth){
        log.error("writeBackRecord.yearMonth:"+yearMonth);
        Map<String, Object> actionMap = new HashMap<>();
        try {
                //查询干部绩效评定结果
                List<Map<String, Object>> leaderPdInfo = employeeRelationService.queryLeaderPdByYear(yearMonth);
                log.error("resultCalculAtion.leaderPdInfo:{}", leaderPdInfo);
                //循环计算干部总分及等级
                if(CollectionUtils.isNotEmpty(leaderPdInfo)){
                    for (Map<String, Object> map : leaderPdInfo) {
                        //将得分、等级回写到干部考核备案表
                        employeeRelationService.updateLeaderDaInfo(map);
                    }
                }
                actionMap.put("code","200");
                actionMap.put("msg","接口调用成功！");
        }catch(Exception e){
            log.error("接口调用失败-e:{}",e);
            actionMap.put("code","201");
            actionMap.put("msg","接口调用失败！");
        }
        return actionMap;
    }

}