package com.weaver.seconddev.jcl.organization.esb;

import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.seconddev.jcl.organization.util.DatabaseUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @use：定时更新人员调动数据
 * @date 2025年3月12日
 * @author xuxy
 */
@Service("updateEmployeeTransferInfo_jcl")
public class UpdateYgddInfoAction implements EsbServerlessRpcRemoteInterface {

    @Autowired
    private DatabaseUtils databaseUtils;

    private static final Logger log = LoggerFactory.getLogger(UpdateYgddInfoAction.class);

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> params) {
        Map<String, Object> rs =new HashMap<>();
        //查询员工调动信息
        List<Map<String, Object>> list = queryYgddInfo();
        //遍历判断是否有当天零点的调动生效日期的人员，更新
        Map<String, Object> result = updateYgddInfo(list);
        log.error("UpdateYgddInfoAction.flowV3:"+result);
        rs.put("flowV3",result);
        return WeaResult.success(rs);
    }

    public List<Map<String, Object>> queryYgddInfo() {
        String sql=" SELECT * from uf_jcl_rydd where delete_type=0 and TENANT_KEY='t7n9jpeaoa' " ;
        log.error("queryYgddInfo.sql:{}",sql);
        Map<String, Object> rs = databaseUtils.execute("LOGIC", "weaver-ebuilder-form-service", sql);
        List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(rs);
        log.error("queryYgddInfo.recordList:{}",recordList);
        return recordList;
    }

    public Map<String, Object> updateYgddInfo(List<Map<String, Object>> list) {
            Map<String, Object> rs = new HashMap<>();
            for (Map<String, Object> map : list) {
                String ddr = String.valueOf(map.get("ddr"));
                String ddsxrq = String.valueOf(map.get("ddsxrq"));
                String ddhgs = String.valueOf(map.get("ddhgs"));
                String ddhbm = String.valueOf(map.get("ddhbm"));
                String ddhgw = String.valueOf(map.get("ddhgw"));
                String ddhzjsj = String.valueOf(map.get("ddhzjsj"));
                //审批状态
                String status = String.valueOf(map.get("flow_status"));
                //判断调动生效日期是否为当天
                if (isToday(ddsxrq)||"3".equals(status)) {
                    //更新数据到员工基础信息表
                    String sql = "update eteams.employee set department = '" + ddhbm + "',POSITION = '" + ddhgw + "',SUPERIOR = '" + ddhzjsj + "'" +
                            " where id = '" + ddr + "' and TENANT_KEY = 't7n9jpeaoa' and delete_type=0 ";
                    log.error("UpdateYgddInfoAction.sql:{}", sql);
                    rs = databaseUtils.execute("LOGIC", "weaver-ebuilder-form-service", sql);
                    log.error("UpdateYgddInfoAction.rs:{}", rs);
                }
            }
        return rs;
    }

    public static boolean isToday(String dateStr) {
        // 定义日期格式
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

        // 解析日期字符串
        try {
            Date inputDate = dateFormat.parse(dateStr);

            // 获取当前日期
            Calendar calendar = Calendar.getInstance();
            Date today = calendar.getTime();

            // 重置时间部分，只比较日期部分
            calendar.setTime(inputDate);
            calendar.set(Calendar.HOUR_OF_DAY, 0);
            calendar.set(Calendar.MINUTE, 0);
            calendar.set(Calendar.SECOND, 0);
            calendar.set(Calendar.MILLISECOND, 0);
            Date truncatedInputDate = calendar.getTime();

            calendar.setTime(today);
            calendar.set(Calendar.HOUR_OF_DAY, 0);
            calendar.set(Calendar.MINUTE, 0);
            calendar.set(Calendar.SECOND, 0);
            calendar.set(Calendar.MILLISECOND, 0);
            Date truncatedTodayDate = calendar.getTime();

            // 比较日期
            return truncatedInputDate.equals(truncatedTodayDate);
        } catch (ParseException e) {
            // 如果解析失败，返回 false
            e.printStackTrace();
            return false;
        }
    }

}
